function makeReplaceTable ()
	if not (global) then global = {} end
	if (global.replaceTable) then return end
	global.replaceTable = {
		{name = "transport-belt", type = "transport-belt" , tier = 1},
		{name = "underground-belt", type = "underground-belt" , tier = 1},
		{name = "loader", type = "loader" , tier = 1},
		{name = "splitter", type = "splitter" , tier = 1},

		{name = "fast-transport-belt", type = "transport-belt" , tier = 2},
		{name = "fast-underground-belt", type = "underground-belt" , tier = 2},
		{name = "fast-loader", type = "loader" , tier = 2},
		{name = "fast-splitter", type = "splitter" , tier = 2},

		{name = "express-transport-belt", type = "transport-belt" , tier = 3},
		{name = "express-underground-belt", type = "underground-belt" , tier = 3},
		{name = "express-loader", type = "loader" , tier = 3},
		{name = "express-splitter", type = "splitter" , tier = 3}
		}
		
end

-- we are need
-- on tick
-- position, direction, name of new entity


script.on_event(defines.events.on_preplayer_mined_item, function (event)
	event_if_replace (event, "first")
	--printAll("premined " .. event.entity.name .. " " .. event.entity.type)
end)

script.on_event(defines.events.on_built_entity, function (event)
	event_if_replace (event, "second")
	--printAll("build " .. event.created_entity.name .. " " .. event.created_entity.type)
end)

script.on_event(defines.events.on_tick, function (event)
	--printall(text)
	on_tick_handler(event)	
end)

function event_if_replace (event, tstring)
	local player_index = event.player_index
	local entity = event.entity or event.created_entity
	printAll ({"was actual direction ", entity.direction})
	--printAll("entity " .. entity.name .. " " .. entity.type .. " " .. tstring )
	try_init ()
	local tick = game.tick
	if tstring == "first" then
		printAll("first")
		global.event_replace[tick] = {}
		global.event_replace_valid = true
		global.event_replace[tick].first = {}
		global.event_replace[tick].first.name = entity.name
		global.event_replace[tick].first.type = entity.type
		global.event_replace[tick].first.position = entity.position
		global.event_replace[tick].first.direction = entity.direction
		global.event_replace[tick].first.surface = entity.surface
		global.event_replace[tick].first.player_index = player_index
		global.event_replace[tick].first.entity = entity
		
	elseif ((tstring == "second") and 
			(global.event_replace_valid) and 
			(global.event_replace[tick])) then
		printAll("second")
		local first_position = global.event_replace[tick].first.position
		local second_position = entity.position
		if comparePositions (first_position, second_position) then
			--printAll("positions ok")
			local first = global.event_replace[tick].first
			local second = {}
				second.name = entity.name
				second.type = entity.type
				second.position = entity.position
				second.direction = entity.direction
				second.surface = entity.surface
				second.player_index = player_index
				second.entity = entity
				
				handler_event_on_replace (first, second)
				
				global.event_replace_valid = false
		end
	elseif global.event_replace[tick] then
		-- do nothing
		printAll("same tick")
		
	else 
		--printAll("event_replace was deleted: " .. #global.event_replace) 
		global.event_replace = nil
	end
	
end

function handler_event_on_replace (first, second)
	printAll("it was replacing!")
	
	local surface = first.surface or second.surface
	local position = first.position or second.position
	local direction = first.direction or second.direction or 0
	printAll ("#102 " .. direction)
	local elements = findElements (position, surface, direction)
	local newTier = getTier (second.name)
	
	if not elements then 
		printAll("no elements")
		return 
	end
	
	for i, element in pairs (elements) do
		printAll ("#112 " .. element.direction)
		element.tier = getTier (second.name)
		element.player_index = second.player_index
		addToTable (element)
	end
	
end

function try_init ()
	if not (global) then global = {} end
	if not (global.event_replace) then global.event_replace = {} end
	if not (global.elementsTable) then global.elementsTable = {} end
	
	-- global.event_replace = {}
end



function on_tick_handler(event)
	
	if not ((game.tick + 1) % 6 == 0) then return end -- ten times pro second
	if not (global and global.elementsTable) then return end
	-- find entities around elements
	local n = 0
	
	-- find first element in table
	for i, v in pairs (global.elementsTable) do
		n = i
		break
	end
	
	if (n == 0) then return end
	
	local element = global.elementsTable[n]
	
	local surface = element.surface or game.surfaces[1]
	local position = element.position
	local direction = element.direction
	local player_index = element.player_index
	local tier = element.tier

	--printAll ({"#145", n , element})
	-- replace entity with element
	
	if not (element.tier == element.tierOld) then
		local name = getNameFromTypeAndTier (element.type, element.tier)
		printAll ("")
		surface.create_entity{name=name, position=position, direction=direction, fast_replace=true, player = game.players[player_index], force = game.players[player_index].force}
		else
		global.elementsTable[n] = nil
	end

			
	-- find next
	local elements = findElements (position, surface, direction, player_index, tier)
	elementsToTable (elements, tier)
	
	printAll("#163 elements to table " .. n .. " / " .. #global.elementsTable)
	
	-- delete first
	global.elementsTable[n] = nil
	
	-- if #global.elementsTable == 0 then
		-- printAll("#167 destoy all elementsTable")
		-- global.elementsTable = {}
	-- end
	
end

function elementsToTable (elements, tier)
	
	if not (elements) then 
		printAll("#180 no elements")
		return 
	end
	
	if not (tier) then 
		printAll("#185 no tier")
		return 
	end

	printAll("#189 elements " .. #elements)
	for i, element in pairs (elements) do
		if not ((tier == element.tier) or (tier == element.tierOld))  then
			local oldTier = element.tierOld
			--local tier = element.tier
			element.tier = tier
			if not (oldTier == tier) then
				local type = element.type
				--element.player_index = element.player_index
				addToTable (element)
			end
		end
	end
end

function findElements (position, surface, direction, player_index, tier)
	--local position = entity.position
	--printAll ("#211 dir was: " .. direction .. " and now " .. normDirection(direction))
	local direction = normDirection(direction) or 0
	--printAll("#210 direction " .. direction)
	--printAll({"#214 direction ", direction})
	local surface = surface or game.surface[1]
	local elements = {}
	local n = 0
	if not (global.replaceTable) then makeReplaceTable () end
	local replaceTable = global.replaceTable
	--printAll("#217 direction + 7 " .. direction + 7)
	for i1 = direction, direction + 6, 2 do 
		local nDir = normDirection(i1)
		--printAll("#220 nDir " .. nDir)
		--printAll({i1, "direction ", direction})
		--printAll({i1, "nDir ", nDir})
		local mPos = directionToPosition(nDir, position)
		--printAll({"mPos", mPos})
		for i2, v in pairs (replaceTable) do
			--printAll ("#175 " .. v.name)
			--local entity = surface.find_entities_filtered{name = v.name, position = mPos}
			local entity = surface.find_entity(v.name, mPos)
			
			if entity then
				local entityDirection = entity.direction
				--printAll("#226 entityDirection:" .. entityDirection .. " direction" .. direction)
				--printAll({"#227 nDir:", nDir})
				
				local bool = false
				
				if (nDir == direction) then 
					bool = true
				end
				
				if (nDir == normDirection(entityDirection+4)) then
					printAll({"#241 was ok", nDir})
					bool = true
					else
					printAll({"#244 wasnt ok", nDir, normDirection(entityDirection+4)})
				end
				
				if (tier == getTier (entity.name)) then
					printAll({"#248 wasnt ok", tier})
					bool = false
					else
					
					printAll({"#251 was ok", tier, getTier (entity.name)})
				end
				
				if (bool) then
					printAll("#256")
					elements[i1] = {}
					local element = elements[i1]
					n = n + 1
					--printAll({"#229 is ", v.name})
					--elements[i1].entity = entity
					element.name = entity.name
					element.type = entity.type
					element.position = entity.position
					element.direction = entity.direction
					element.tierOld = v.tier
					element.player_index = player_index
					printAll({"#240", elements[i1]})
					
					if entity.type == "underground-belt" then
						printAll({"#254", entity.neighbours})
						--for _, neighbour in pairs(entity.neighbours) do
							addEntity (entity.neighbours, element)
						--end
					end
				end
				else
			end
		end
	end
	
	if n > 0 then
		--printAll({"#261 was elements ", #elements})
		return elements
	else
		printAll({"#264 was elements ", #elements})
	end
end


function addEntity (entity, element)
	if not (entity) then return end
	local newElement = {}
	newElement.type = entity.type
	newElement.tier = element.tier
	newElement.tierOld = element.tier
	newElement.name = getNameFromTypeAndTier (entity.type, element.tier)
	newElement.position = entity.position
	newElement.direction = entity.direction
	newElement.player_index = element.player_index
	printAll({"#303 newElement ", newElement.name, entity.type, element.tier})
	addToTable (newElement)
end

function addToTable (element)
	--global.elementsTable
	local nextID = getNextID (global.elementsTable) or 1
	global.elementsTable[nextID] = element
end



-------------- utils -------------

function getNextID (table)
	local n = 0
	if type(table) == "table" then
		if #table >0 then
			for i, v in pairs (table) do
				n = i
			end
			return n + 1
		end
		printAll("table was empty")
	end
	printAll("it wasn't table")
end

function getTier (entityName)
	local replaceTable = global.replaceTable
	for i, v in pairs (replaceTable) do
		if (entityName == v.name) then
			return v.tier
		end
	end
	printAll(entityName .. " is not in replaceTable! No tier.")
	return false
end

function getType (entityName)
	for i, v in pairs (replaceTable) do
		if (entityName == v.name) then
			return v.type
		end
	end
	printAll(entityName .. " is not in replaceTable! No type.")
	return false
end

function getNameFromTypeAndTier (type, tier)
	--makeReplaceTable ()
	if not type then printAll("#320 no type" )  return end
	if not tier then printAll("#321 no tier" )  return end
	
	for i, v in pairs (global.replaceTable) do
		if ((type == v.type) and ((tier == v.tier))) then
			return v.name
		end
	end
	printAll("#325 It was not in replaceTable! No name. Type:" .. type .. " tier: " .. tier)
	return false
end

function directionToPosition(direction, position)
	-- makes position from direction, absolute or relative
	local newPosition = {x=0, y=0}
	local oldPosition = position or {x=0, y=0}
	--printAll("#254 direction " .. direction)
	
	direction = normDirection(direction)
	--printAll("#257 direction " .. direction)
	if 			direction == 0 then newPosition = {	x=0, 	y=-1}
		elseif 	direction == 2 then newPosition = {	x=1, 	y=0}
		elseif 	direction == 4 then newPosition = {	x=0, 	y=1}
		elseif 	direction == 6 then newPosition = {	x=-1, y=0}

		else return nil 
	end
	newPosition = {x = oldPosition.x + newPosition.x, y = oldPosition.y + newPosition.y}
	--printAll("oldPosition x:" .. oldPosition.x .. " y:" .. oldPosition.y)
	--printAll("newPosition x:" .. newPosition.x .. " y:" .. newPosition.y)
	return newPosition
end

function normDirection(direction)
	printAll("#374 direction " .. direction .. " newDir " ..direction % 8)
	return direction % 8
end

function comparePositions (pos1, pos2)
	--printAll("x1: " .. pos1.x .. " x2: " .. pos2.x)
	--printAll("y1: " .. pos1.y .. " y2: " .. pos2.y)
	if not (pos1 and pos2) then return false end
	if not ((type (pos1) == "table") and (type (pos2) == "table")) then return false end
	if ((pos1.x == pos2.x) and (pos1.y == pos2.y)) then return true end
	printAll("not same position, how?")
	return false
end

function printAll(text)
	if type(text) == "table" then text = serpent.block(text, {comment = false}) end
	for player_index, player in pairs (game.players) do
		game.players[player_index].print (text)
	end
end

function tableContains(table, element)
  for i, value in pairs(table) do
    if value == element then
      return value
    end
	 if type(value) == "table" then
		local valueOrFalse = tableContains(value, element)
		if valueOrFalse then return i end
	 end
  end
  return false
end